#ifndef CGSYSTEM_H_
#define CGSYSTEM_H_
#include "commonHeader.h"

template <class T>
class CGsystem{
public:
	CGsystem(){}
	virtual ~CGsystem() {};
	virtual T ** initVectors(T **x, T **b, const int length) = 0;
	virtual T vectorVectorProduct(const T*v1, const T *v2) const = 0;
	virtual void matrixVectorProduct(const T *v, T *result) const = 0;
	virtual void axpy(const T a, const T *x, T *y) const = 0;
	virtual void scale(const T scalar, T *v) const =0;
	virtual void copy(const T *src, T **dst) const =0;
	virtual void getSolution(T **solution) const = 0;
	virtual size_type getN() const = 0;
	virtual void printVector(const T *v, const int numbersPerLine = 32) const = 0;
	virtual void printMatrix() const = 0;
};

#endif /*CGSYSTEM_H_*/
