/* Copyright 2008 NVIDIA Corporation.  All Rights Reserved */

#pragma once

#include "spmv/sparse_formats.h"
#include "spmv/spmv_ell_device.cu.h"
#include "spmv/spmv_coo_flat_device.cu.h"

// SpMV kernels for the hybrid ELL/COO matrix format.

template <typename IndexType, typename ValueType>
void spmv_hyb_device(const hyb_matrix<IndexType,ValueType>& d_hyb, 
                     const ValueType * d_x, 
                           ValueType * d_y)
{
    spmv_ell_device(d_hyb.ell, d_x, d_y);
    spmv_coo_flat_device(d_hyb.coo, d_x, d_y);
}

template <typename IndexType, typename ValueType>
void spmv_hyb_tex_device(const hyb_matrix<IndexType,ValueType>& d_hyb, 
                         const ValueType * d_x, 
                               ValueType * d_y)
{
    spmv_ell_tex_device(d_hyb.ell, d_x, d_y);
    spmv_coo_flat_tex_device(d_hyb.coo, d_x, d_y);
}

