#include "commonHeader.h"
#include "cuda.h"
#include "cutil_inline.h"
#include "MyProject.h"
#include "MyProject_kernel.cu"
int main(){
	double *q = new double[64];
	for (int i=1; i < 64 - 1; i++) q[i] = 0;
	q[0] = 1;
	q[63] = -1;
	double *x;
	unsigned int n = 64;
	cutilSafeCall(cudaMalloc((void**)&x, n*sizeof(double)));
	
	/*make x random for debug purposes */
	double *temp = new double[n];
	for (int i=0; i<n; ++i){
		temp[i] = exp((double) rand()/RAND_MAX);
	}
	temp[2] = 1.0/0.0;//infinity
	temp[4] = 0.0/0.0;//nan
	cutilSafeCall(cudaMemcpy(x, temp, n*sizeof(double), cudaMemcpyHostToDevice));
	delete[] temp;
	
	MyProjectPrintVector(64, true, x);
	scale_kernel<<< 1,64 >>>(0.0, x);
	cutilSafeCall(cudaGetLastError());
	MyProjectPrintVector(64, true, x);
	
	cutilSafeCall(cudaFree(x));	
}